package
{
	import controller.ChangeViewCommand;
	import controller.StartupCommand;
	
	import flash.display.DisplayObjectContainer;
	
	import models.ViewModel;
	
	import org.robotlegs.base.ContextEvent;
	import org.robotlegs.mvcs.Context;
	import org.robotlegs.mvcs.SignalContext;
	
	import signals.ChangeViewSignal;
	
	import views.components.ViewOne;
	import views.components.ViewTwo;
	import views.mediators.ViewOneMediator;
	import views.mediators.ViewTwoMediator;

	public class MainContext extends SignalContext
	{
		/**
		 * Models 
		 */
		[Inject]
		public var viewModel:ViewModel;
		
		/**
		 * Signals send / received by the view
		 */
		[Inject]
		public var viewSignal:ChangeViewSignal;
		
		public function MainContext(contextView:DisplayObjectContainer=null, autoStartup:Boolean=true)
		{
			super(contextView, autoStartup);
		}
		
		override public function startup():void
		{
			//map controller
			signalCommandMap.mapSignalClass(ChangeViewSignal, ChangeViewCommand);
			commandMap.mapEvent(ContextEvent.STARTUP, StartupCommand);
			
			//map model
			injector.mapSingleton( ViewModel );
			
			//map service
			
			//map view
			mediatorMap.mapView(ViewOne,ViewOneMediator);
			mediatorMap.mapView(ViewTwo, ViewTwoMediator);
			
			// start up the appliation
			dispatchEvent(new ContextEvent(ContextEvent.STARTUP));
			
		}
	}
}