package controller
{
	import models.ViewModel;
	
	import mx.core.IVisualElement;
	import mx.core.IVisualElementContainer;
	
	import org.robotlegs.mvcs.Command;
	
	import views.components.ViewOne;
	import views.components.ViewTwo;
	
	public class ChangeViewCommand extends Command
	{
		[Inject]
		public var viewModel:ViewModel;
		
		override public function execute():void
		{
			switch(viewModel.nextView)
			{
				case "viewOne":
					if(viewModel.currentView)
						(contextView as IVisualElementContainer).removeElement(viewModel.currentView as IVisualElement);
					(contextView as IVisualElementContainer).addElement(new ViewOne());
					break;
				
				case "viewTwo":
					if(viewModel.currentView)
						(contextView as IVisualElementContainer).removeElement(viewModel.currentView as IVisualElement);
					(contextView as IVisualElementContainer).addElement(new ViewTwo());
					break;
				
				default:
					break;
			}
		}
	}
}