package views.mediators
{
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.system.System;
	
	import models.ViewModel;
	
	import org.robotlegs.mvcs.Mediator;
	
	import signals.ChangeViewSignal;
	
	import views.components.ViewTwo;
	
	public class ViewTwoMediator extends Mediator
	{
		/**
		 * Main View
		 */
		[Inject]
		public var view:ViewTwo;
		
		/**
		 * Models 
		 */
		[Inject]
		public var viewModel:ViewModel;
		
		/**
		 * Signals send / received by the view
		 */
		[Inject]
		public var viewSignal:ChangeViewSignal;
		
		override public function onRegister( ):void
		{
			eventMap.mapListener(view.someLabel, MouseEvent.CLICK, onMouseClick, MouseEvent); 
			if(contextView.contains(view))
				viewModel.currentView = view;
		}
		
		override public function onRemove():void
		{
			trace("view 1 mediator removed");
			//forcing the gc:
			System.gc();
			System.gc();
			//viewModel.currentView=null;
			//view=null;//good but not necessary
			
			eventMap.unmapListeners();	
			super.onRemove();						
		}
		
		private function onMouseClick(evt:MouseEvent):void
		{			
			viewModel.nextView = "viewOne";
			viewSignal.dispatch();			
		}
	}
}